<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
<!--
******************************************************************
*
* File: pass1_xml.xsl
*
* Copyright 2009 Programming Research Ltd
*
* Written: C.Waddingham, 6-August-2009
*
* Purpose: XSL Stylesheet for generating pass1.xml which is the
*          input to master_xhtml.xsl etc.
*
* Usage: Use as input to xsltproc, e.g. (for the code review case):
*        xsltproc <dash><dash>param op "'C:/..../'" pass1_xml.xsl x1_code_review.xml >pass1.xml
*        Where <dash> is -
******************************************************************
-->

<xsl:stylesheet version="1.0"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:svg="http://www.w3.org/2000/svg" 
                xmlns:prqa="http://www.programmingresearch.com/todo" >

<!--
  <xsl:output method="xml"
            doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
            doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
            indent="yes" /> 
-->
  <xsl:output method="xml"
            indent="yes" /> 

  <xsl:param name='op'/>
  <xsl:param name='title'/>
  <xsl:param name='project_name'/>
  <xsl:param name='date'/>
  <xsl:param name='no_appendix' select="false()" />
  <xsl:param name='no_version' select="false()" />
  
  <xsl:template match="/prqa:report">
    <prqa:report>
      <xsl:choose>
        <xsl:when test="$title">
          <prqa:title><xsl:value-of select="$title"/></prqa:title>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="prqa:title"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
        <xsl:when test="$project_name">
          <prqa:project_name><xsl:value-of select="$project_name"/></prqa:project_name>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="prqa:project_name"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
        <xsl:when test="$date">
          <prqa:date><xsl:value-of select="$date"/></prqa:date>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="prqa:date"/>
        </xsl:otherwise>
      </xsl:choose>
      <prqa:front_page>
        <xsl:for-each select="prqa:front_page/prqa:component">
          <xsl:copy-of select="document(concat($op,.))" />
        </xsl:for-each>
      </prqa:front_page>
      <prqa:main>
        <xsl:for-each select="prqa:main/prqa:component">
          <xsl:copy-of select="document(concat($op,.))" />
        </xsl:for-each>
      </prqa:main>
      <prqa:appendices>
        <xsl:if test="not(boolean($no_appendix))">
          <xsl:for-each select="prqa:appendices/prqa:component">
            <xsl:copy-of select="document(concat($op,.))" />
          </xsl:for-each>
          <xsl:if test="not(boolean($no_version))">
            <xsl:for-each select="prqa:version/prqa:component">
              <xsl:copy-of select="document(concat($op,.))"/>
            </xsl:for-each>
          </xsl:if>
        </xsl:if>
      </prqa:appendices>
    </prqa:report>
  </xsl:template>

</xsl:stylesheet>
